#include <stdio.h>      //FILE
#include <stdlib.h>
#include "types.h"

unsigned char* f_lit_binaire(char*nom)
{
    FILE *fsource;
    unsigned char *tamp;
    long curpos,taille;
    //-------------------------- OUVERTURE DU FICHIER ---------------------
    
    if ((fsource=fopen(nom,"rb"))==NULL) 
    {
        printf("ca chie! -> impossible d'ouvrir le fichier: %s \n",nom);
        exit(2);
    }

    //-------------------------- TAILLE DU FICHIER -------------------------

    curpos=ftell(fsource);  
    fseek(fsource,0L,SEEK_END);
    taille=ftell(fsource);
    fseek(fsource,curpos,SEEK_SET); 

    //---------------------- ALLOCATION DE LA MEMOIRE ----------------------
    //printf("name:%s    <---->size:%d  \n",nom,taille);

    if ((tamp=(UBYTE*)malloc(taille))==NULL)

    {
        printf("no enough memory!! for loading: %s",nom);
        exit(1);
    }

  
    //------------------------- LECTURE DU FICHIER -------------------------
	
    if ((fread(tamp,1,taille,fsource))!= taille)
    {
        printf("read error: ca chie a la lecture de :%s",nom);
        exit(3);
    }   

    fclose(fsource);

	//------------- inversion des octets des mots !!!!
	//---------- quand les datas viennent du monde amiga!!
	//--------- windows suxx

	long i;
	unsigned char *ttt=(	unsigned char *)tamp;
	unsigned char swap; 

	for(i=0;i<taille;i+=2)
	{
		//tamp[i]=(ttt[i*2+1]<<8)+ttt[i*2];
		swap=ttt[i];
		ttt[i]=ttt[i+1];
		ttt[i+1]=swap;

	}

    return (tamp);
}

void f_sauve_binaire(char*nom,UBYTE*data,long taille)
{
    FILE *fsource;
   
    //-------------------------- OUVERTURE DU FICHIER ---------------------
    
    if ((fsource=fopen(nom,"wb"))==NULL) 
    {
        printf("ca chie! -> impossible d'ouvrir le fichier: %s \n",nom);
        exit(2);
    }

    //------------------------- LECTURE DU FICHIER -------------------------

    if ((fwrite(data,1,taille,fsource))!= taille)
    {
        printf("ca chie a l ecriture de :%s",nom);
        exit(3);
    }   
    
    fclose(fsource);
}


